//+------------------------------------------------------------------+
//|                                                   Money Tree.mq4 |
//|                               Copyright  2007, Michael Schramm. |
//|                                                                  |
//+------------------------------------------------------------------+

extern double Lots = 0.1;
extern double TakeProfit = 1000;
extern double StopLoss = 1000;
extern double TrailingStop = 1000;
extern double Slippage = 3;
extern int  MagicNumber = 12345;
extern int MaMetod  = 2;
extern int MaPeriod = 6;
extern int MaMetod2  = 3;
extern int MaPeriod2 = 2;
extern int BarWidth = 0;
extern color BarColorUp = Blue;
extern color BarColorDown = Red;
extern color TextColor = White;
extern int MaxBars=500;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double HasColor;
   int cnt, ticket, total, Bar1Up, Bar1Down, Bar2Up, Bar2Down, Bar3Up, Bar3Down, Bar4Up, Bar4Down;

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   

   Bar1Up=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,0,1);
   Bar1Down=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,1,1);
   Bar2Up=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,2,1);
   Bar2Down=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,3,1);
   Bar3Up=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,4,1);
   Bar3Down=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,5,1);
   Bar4Up=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,6,1);
   Bar4Down=iCustom(NULL,0,"N4 TF HAS Bar",MaMetod,MaPeriod,MaMetod2,MaPeriod2,BarWidth,BarColorUp,BarColorDown,TextColor,MaxBars,7,1);
   
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if(Bar2Up==2)
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,"Money Tree in the House",MagicNumber,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(Bar2Down==2)
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,"Money Tree in the House",MagicNumber,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
     
   // Exit Stratagy
    for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(Bar2Down==2)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(Bar2Up==22)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.